## plasma-workspace 5.20.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

project(plasma-workspace)
set(PROJECT_VERSION "5.20.5")
set(PROJECT_VERSION_MAJOR 5)

set(QT_MIN_VERSION "5.15.0")
set(KF5_MIN_VERSION "5.74")
set(INSTALL_SDDM_THEME TRUE)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Svg Widgets Quick QuickWidgets Concurrent Test Network)
find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMMarkNonGuiExecutable)
include(CMakePackageConfigHelpers)
include(WriteBasicConfigVersionFile)
include(CheckIncludeFiles)
include(FeatureSummary)
include(ECMOptionalAddSubdirectory)
include(ECMQtDeclareLoggingCategory)
include(ECMQueryQmake)
include(ECMInstallIcons)
include(KDEPackageAppTemplates)
include(KDEClangFormat)
include(ECMQMLModules)

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
                    Plasma DocTools Runner Notifications NotifyConfig Su NewStuff Wallet
                    IdleTime Declarative I18n KCMUtils TextWidgets KDELibs4Support Crash GlobalAccel
                    DBusAddons Wayland CoreAddons People ActivitiesStats Activities KIO Prison)
find_package(KDED CONFIG REQUIRED)

find_package(KF5NetworkManagerQt ${KF5_MIN_VERSION})
set_package_properties(KF5NetworkManagerQt PROPERTIES DESCRIPTION "Qt wrapper for NetworkManager API"
                       TYPE OPTIONAL
                       PURPOSE "Needed by geolocation data engine."
                      )

find_package(KF5Kirigami2 ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5Kirigami2 PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    TYPE RUNTIME
)

find_package(KF5QuickCharts ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5QuickCharts PROPERTIES
    DESCRIPTION "Used for rendering charts"
    TYPE RUNTIME
)

# WARNING PlasmaQuick provides unversioned CMake config
find_package(KUserFeedback)
find_package(KF5 REQUIRED COMPONENTS PlasmaQuick)
find_package(KSysGuard CONFIG REQUIRED)
find_package(KF5 REQUIRED COMPONENTS Package)

find_package(KF5Baloo)
set_package_properties(KF5Baloo PROPERTIES DESCRIPTION "File Searching"
                       TYPE RECOMMENDED
                       PURPOSE "Needed for the File Search runner."
                      )

find_package(KF5TextEditor)
find_package(KWinDBusInterface CONFIG REQUIRED)

find_package(KF5Screen CONFIG REQUIRED)
find_package(KScreenLocker 5.13.80 REQUIRED)
find_package(ScreenSaverDBusInterface CONFIG REQUIRED)
find_package(KF5Holidays)
set_package_properties(KF5Holidays PROPERTIES DESCRIPTION "Holidays provider for Plasma calendar"
                       TYPE OPTIONAL
                       PURPOSE "Needed to for holidays plugin for Plasma Calendar."
                      )

find_package(Phonon4Qt5 4.6.60 REQUIRED NO_MODULE)
set_package_properties(Phonon4Qt5 PROPERTIES
   DESCRIPTION "Qt-based audio library"
   TYPE REQUIRED)

find_package(Breeze ${PROJECT_VERSION} CONFIG)
set_package_properties(Breeze PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "For setting the default window decoration plugin")

find_package(ZLIB)
set_package_properties(ZLIB PROPERTIES DESCRIPTION "Support for gzip compressed files and data streams"
                       URL "https://www.zlib.net"
                       TYPE REQUIRED
                      )

find_package(Fontconfig)
set_package_properties(Fontconfig PROPERTIES DESCRIPTION "Font access configuration library"
                       URL "https://www.freedesktop.org/wiki/Software/fontconfig"
                       TYPE OPTIONAL
                       PURPOSE "Needed to build font configuration and installation tools"
                      )


find_package(X11)
set_package_properties(X11 PROPERTIES DESCRIPTION "X11 libraries"
                        URL "https://www.x.org"
                        TYPE OPTIONAL
                        PURPOSE "Required for building the X11 based workspace")

find_package(PkgConfig REQUIRED)
pkg_check_modules(PipeWire IMPORTED_TARGET libpipewire-0.3)
add_feature_info(PipeWire PipeWire_FOUND "Required for Wayland screencasting")

if(PipeWire_FOUND)
  find_package(Libdrm REQUIRED)
endif()

find_package(QtWaylandScanner REQUIRED)
find_package(PlasmaWaylandProtocols REQUIRED)
find_package(Wayland REQUIRED COMPONENTS Client)

if(X11_FOUND)
  find_package(XCB MODULE REQUIRED COMPONENTS XCB RANDR IMAGE)
  set_package_properties(XCB PROPERTIES TYPE REQUIRED)
  if(NOT X11_SM_FOUND)
    message(FATAL_ERROR "\nThe X11 Session Management (SM) development package could not be found.\nPlease install libSM.\n")
  endif(NOT X11_SM_FOUND)

  find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS X11Extras)
endif()

if(X11_FOUND AND XCB_XCB_FOUND)
  set(HAVE_X11 1)
endif()

find_package(AppStreamQt 0.10.6)
set_package_properties(AppStreamQt PROPERTIES DESCRIPTION "Access metadata for listing available software"
                       URL "https://www.freedesktop.org/wiki/Distributions/AppStream/"
		       TYPE OPTIONAL
                      )

if(${AppStreamQt_FOUND})
    set(HAVE_APPSTREAMQT true)
endif()

# Fonts kcm and kfontinst
find_package(Freetype)
set_package_properties(Freetype PROPERTIES DESCRIPTION "A font rendering engine"
                       URL "https://www.freetype.org"
                       TYPE OPTIONAL
                       PURPOSE "Needed to build kfontinst, a simple font installer."
                      )

# Clipboard applet
ecm_find_qmlmodule(org.kde.prison 1.0)

include(ConfigureChecks.cmake)

include_directories("${CMAKE_CURRENT_BINARY_DIR}")

configure_file(config-workspace.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-workspace.h)
configure_file(config-unix.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-unix.h )
configure_file(config-X11.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-X11.h)
configure_file(config-appstream.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-appstream.h )
add_subdirectory(login-sessions)

plasma_install_package(lookandfeel org.kde.breeze.desktop look-and-feel lookandfeel)

if (INSTALL_SDDM_THEME)
    configure_file(sddm-theme/theme.conf.cmake ${CMAKE_CURRENT_BINARY_DIR}/sddm-theme/theme.conf)

# Install the login theme into the SDDM directory
# Longer term we need to look at making SDDM load from look and feel somehow.. and allow copying at runtime
    #NOTE this trailing slash is important to rename the directory
    install(DIRECTORY sddm-theme/ DESTINATION ${KDE_INSTALL_FULL_DATADIR}/sddm/themes/breeze PATTERN "README.txt" EXCLUDE PATTERN "components" EXCLUDE PATTERN "dummydata" EXCLUDE
    PATTERN "theme.conf.cmake" EXCLUDE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sddm-theme/theme.conf DESTINATION ${KDE_INSTALL_FULL_DATADIR}/sddm/themes/breeze)
    install(DIRECTORY lookandfeel/contents/components DESTINATION ${KDE_INSTALL_FULL_DATADIR}/sddm/themes/breeze PATTERN "README.txt" EXCLUDE)

endif()

add_definitions(-DQT_NO_URL_CAST_FROM_STRING)

# locate qdbus in the Qt path because not every distro makes a symlink at /usr/bin/qdbus
query_qmake(QtBinariesDir QT_INSTALL_BINS)

add_subdirectory(doc)
add_subdirectory(libkworkspace)
add_subdirectory(libdbusmenuqt)
add_subdirectory(appmenu)

add_subdirectory(libtaskmanager)
add_subdirectory(libnotificationmanager)
add_subdirectory(libcolorcorrect)
add_subdirectory(components)

add_subdirectory(plasma-windowed)
add_subdirectory(shell)
add_subdirectory(freespacenotifier)
add_subdirectory(klipper)
add_subdirectory(krunner)
add_subdirectory(ksmserver)
add_subdirectory(logout-greeter)
add_subdirectory(ksplash)
add_subdirectory(systemmonitor)
add_subdirectory(statusnotifierwatcher)
add_subdirectory(startkde)
add_subdirectory(themes)

add_subdirectory(kcms)

add_subdirectory(containmentactions)
add_subdirectory(runners)
add_subdirectory(applets)
add_subdirectory(dataengines)
add_subdirectory(wallpapers)

add_subdirectory(kioslave)
add_subdirectory(ktimezoned)
add_subdirectory(menu)
add_subdirectory(phonon)

# This ensures pressing the eject button on a CD drive ejects the disc
# It listens to the Solid::OpticalDrive::ejectPressed signal that is only
# supported by Solid in the HAL backend and does nothing with UDev
if(CMAKE_SYSTEM_NAME MATCHES FreeBSD)
add_subdirectory(solidautoeject)
endif()

ecm_optional_add_subdirectory(xembed-sni-proxy)

ecm_optional_add_subdirectory(gmenu-dbusmenu-proxy)

add_subdirectory(soliduiserver)

if(KF5Holidays_FOUND)
    add_subdirectory(plasmacalendarintegration)
endif()

add_subdirectory(templates)

install(FILES plasma-workspace.categories   DESTINATION  ${KDE_INSTALL_LOGGINGCATEGORIESDIR})
feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

# add clang-format target for all our real source files
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

  find_package(KF5DocTools CONFIG)
  if(KF5DocTools_FOUND)
    kdoctools_install(po)
  endif()

=== freespacenotifier/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"freespacenotifier\")

set(kded_freespacenotifier_SRCS freespacenotifier.cpp module.cpp)

ki18n_wrap_ui(kded_freespacenotifier_SRCS freespacenotifier_prefs_base.ui)

qt5_add_dbus_interface(kded_freespacenotifier_SRCS ${KDED_DBUS_INTERFACE} kded_interface)

kconfig_add_kcfg_files(kded_freespacenotifier_SRCS settings.kcfgc)

add_library(freespacenotifier MODULE ${kded_freespacenotifier_SRCS})
kcoreaddons_desktop_to_json(freespacenotifier freespacenotifier.desktop)

target_link_libraries(freespacenotifier
    KF5::ConfigWidgets
    KF5::DBusAddons
    KF5::I18n
    KF5::KIOCore
    KF5::KIOGui
    KF5::Notifications
    KF5::Service
)

install(TARGETS freespacenotifier  DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf5/kded )


########### install files ###############

install( FILES freespacenotifier.notifyrc  DESTINATION  ${KDE_INSTALL_KNOTIFY5RCDIR} )
install( FILES freespacenotifier.kcfg  DESTINATION  ${KDE_INSTALL_KCFGDIR} )

=== gmenu-dbusmenu-proxy/CMakeLists.txt ===
find_package(AppMenuGtkModule)
set_package_properties(AppMenuGtkModule PROPERTIES TYPE RUNTIME)

add_definitions(-DQT_NO_CAST_TO_ASCII
-DQT_NO_CAST_FROM_ASCII
-DQT_NO_URL_CAST_FROM_STRING
-DQT_NO_CAST_FROM_BYTEARRAY)

find_package(XCB
    REQUIRED COMPONENTS
        XCB
)

set(GMENU_DBUSMENU_PROXY_SRCS
    main.cpp
    menuproxy.cpp
    window.cpp
    menu.cpp
    actions.cpp
    gdbusmenutypes_p.cpp
    icons.cpp
    utils.cpp
    ../libdbusmenuqt/dbusmenutypes_p.cpp
 )

qt5_add_dbus_adaptor(GMENU_DBUSMENU_PROXY_SRCS ../libdbusmenuqt/com.canonical.dbusmenu.xml window.h Window)

ecm_qt_declare_logging_category(GMENU_DBUSMENU_PROXY_SRCS HEADER debug.h
                                               IDENTIFIER DBUSMENUPROXY
                                               CATEGORY_NAME kde.dbusmenuproxy
                                               DEFAULT_SEVERITY Info)

add_executable(gmenudbusmenuproxy ${GMENU_DBUSMENU_PROXY_SRCS})

set_package_properties(XCB PROPERTIES TYPE REQUIRED)

target_link_libraries(gmenudbusmenuproxy
    Qt5::Core
    Qt5::X11Extras
    Qt5::DBus
    KF5::CoreAddons
    KF5::ConfigCore
    KF5::WindowSystem
    XCB::XCB
)

install(TARGETS gmenudbusmenuproxy ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES gmenudbusmenuproxy.desktop DESTINATION ${KDE_INSTALL_AUTOSTARTDIR})

=== kcms/CMakeLists.txt ===
add_subdirectory(desktoptheme)
add_subdirectory(icons)
add_subdirectory(translations)

if(KUserFeedback_FOUND)
    add_subdirectory(feedback)
endif()

add_subdirectory(style)
add_subdirectory(krdb)
add_subdirectory(lookandfeel)
add_subdirectory(colors)
if(X11_Xcursor_FOUND)
    add_subdirectory(cursortheme)
endif()

set(libkxftconfig_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/fonts/kxftconfig.cpp )

if(FONTCONFIG_FOUND AND FREETYPE_FOUND)
    add_subdirectory( kfontinst )
    add_subdirectory( fonts )
endif()

=== klipper/CMakeLists.txt ===
set(KLIPPER_VERSION_STRING ${PROJECT_VERSION})
add_definitions(-DTRANSLATION_DOMAIN=\"klipper\")
add_definitions("-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII")
add_definitions(-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)
add_definitions(-DQT_NO_URL_CAST_FROM_STRING)

add_subdirectory(systemclipboard)

set(libklipper_common_SRCS
    klipper.cpp
    urlgrabber.cpp
    configdialog.cpp
    history.cpp
    historyitem.cpp
    historymodel.cpp
    historystringitem.cpp
    klipperpopup.cpp
    popupproxy.cpp
    historyimageitem.cpp
    historyurlitem.cpp
    actionstreewidget.cpp
    editactiondialog.cpp
    clipcommandprocess.cpp
)

ecm_qt_declare_logging_category(libklipper_common_SRCS HEADER klipper_debug.h IDENTIFIER KLIPPER_LOG CATEGORY_NAME org.kde.klipper)

configure_file(config-klipper.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-klipper.h )

ki18n_wrap_ui(libklipper_common_SRCS generalconfig.ui actionsconfig.ui editactiondialog.ui)
kconfig_add_kcfg_files(libklipper_common_SRCS klippersettings.kcfgc)

set(klipper_KDEINIT_SRCS ${libklipper_common_SRCS} main.cpp tray.cpp)

kf5_add_kdeinit_executable(klipper ${klipper_KDEINIT_SRCS})

target_link_libraries(kdeinit_klipper
    Qt5::Concurrent
    KF5::ConfigGui
    KF5::CoreAddons
    KF5::DBusAddons
    KF5::GlobalAccel
    KF5::KIOWidgets
    KF5::Notifications
    KF5::Service
    KF5::Prison
    KF5::TextWidgets
    KF5::WindowSystem
    KF5::WidgetsAddons
    KF5::XmlGui
    ${ZLIB_LIBRARY}
    systemclipboard
)
if (X11_FOUND)
  target_link_libraries(kdeinit_klipper XCB::XCB Qt5::X11Extras)
endif()

install(TARGETS kdeinit_klipper ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(TARGETS klipper         ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(PROGRAMS org.kde.klipper.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(PROGRAMS klipper.desktop DESTINATION ${KDE_INSTALL_AUTOSTARTDIR})

# Plasma Data Engine
set(plasma_engine_clipboard_SRCS ${libklipper_common_SRCS} clipboardengine.cpp clipboardservice.cpp clipboardjob.cpp)
add_library(plasma_engine_clipboard MODULE ${plasma_engine_clipboard_SRCS})
kcoreaddons_desktop_to_json(plasma_engine_clipboard plasma-dataengine-clipboard.desktop)
target_link_libraries(plasma_engine_clipboard
    Qt5::Concurrent
    Qt5::DBus
    Qt5::Widgets       # QAction
    KF5::ConfigGui
    KF5::CoreAddons    # KUrlMimeData
    KF5::GlobalAccel
    KF5::KIOWidgets    # PreviewJob
    KF5::Plasma
    KF5::Notifications
    KF5::Service
    KF5::Prison
    KF5::TextWidgets   # KTextEdit
    KF5::WidgetsAddons # KMessageBox
    KF5::WindowSystem
    KF5::XmlGui        # KActionCollection
    ${ZLIB_LIBRARY}
    systemclipboard
)
if (X11_FOUND)
  target_link_libraries(plasma_engine_clipboard XCB::XCB Qt5::X11Extras)
endif()
install(TARGETS plasma_engine_clipboard DESTINATION ${KDE_INSTALL_PLUGINDIR}/plasma/dataengine)
install(FILES plasma-dataengine-clipboard.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR})
install(FILES org.kde.plasma.clipboard.operations DESTINATION ${PLASMA_DATA_INSTALL_DIR}/services)
if(BUILD_TESTING)
   add_subdirectory(autotests)
endif()

install( FILES klipper.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR} )

=== krunner/CMakeLists.txt ===
set(krunner_SRCS
    main.cpp
    view.cpp
)

set(krunner_dbusAppXML dbus/org.kde.krunner.App.xml)
qt5_add_dbus_adaptor(krunner_SRCS ${krunner_dbusAppXML} view.h View)
configure_file(dbus/org.kde.krunner.service.in
               ${CMAKE_CURRENT_BINARY_DIR}/org.kde.krunner.service)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.krunner.service
        DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR})


add_executable(krunner ${krunner_SRCS})

target_link_libraries(krunner
    Qt5::Quick
    Qt5::Widgets
    KF5::KIOWidgets
    KF5::Declarative
    KF5::I18n
    KF5::PlasmaQuick
    KF5::DBusAddons
    KF5::Crash
    KF5::WaylandClient
    KF5::QuickAddons
    PW::KWorkspace
)
target_compile_definitions(krunner PRIVATE -DPROJECT_VERSION="${PROJECT_VERSION}")

install(TARGETS krunner ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES ${krunner_dbusAppXML} DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR} )

install(FILES krunner.desktop DESTINATION ${DATA_INSTALL_DIR}/kglobalaccel)

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KRunnerAppDBusInterface")
configure_package_config_file(KRunnerAppDBusInterfaceConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/KRunnerAppDBusInterfaceConfig.cmake"
    PATH_VARS KDE_INSTALL_DBUSINTERFACEDIR
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/KRunnerAppDBusInterfaceConfig.cmake
    DESTINATION ${CMAKECONFIG_INSTALL_DIR})

add_subdirectory(update)

=== libkworkspace/CMakeLists.txt ===

set(kworkspace_LIB_SRCS kdisplaymanager.cpp
                        kworkspace.cpp
                        sessionmanagement.cpp
                        sessionmanagementbackend.cpp
                        updatelaunchenvjob.cpp
   )

add_definitions(-DTRANSLATION_DOMAIN=\"libkworkspace\")
remove_definitions(-DQT_NO_CAST_FROM_ASCII)
remove_definitions(-DQT_NO_CAST_FROM_BYTEARRAY)
remove_definitions(-DQT_NO_CAST_TO_ASCII)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

qt5_add_dbus_interface(kworkspace_LIB_SRCS ${KINIT_DBUS_INTERFACES_DIR}/kf5_org.kde.KLauncher.xml klauncher_interface)
qt5_add_dbus_interface(kworkspace_LIB_SRCS ${KSCREENLOCKER_DBUS_INTERFACES_DIR}/kf5_org.freedesktop.ScreenSaver.xml screenlocker_interface )
qt5_add_dbus_interface(kworkspace_LIB_SRCS ${KSCREENLOCKER_DBUS_INTERFACES_DIR}/org.kde.screensaver.xml kscreenlocker_interface )
qt5_add_dbus_interface(kworkspace_LIB_SRCS ${plasma-workspace_SOURCE_DIR}/ksmserver/org.kde.LogoutPrompt.xml logoutprompt_interface)
qt5_add_dbus_interface(kworkspace_LIB_SRCS ${plasma-workspace_SOURCE_DIR}/startkde/plasma-session/org.kde.Startup.xml startup_interface)
qt5_add_dbus_interface(kworkspace_LIB_SRCS ${plasma-workspace_SOURCE_DIR}/startkde/plasma-shutdown/org.kde.Shutdown.xml shutdown_interface)

set_source_files_properties("${CMAKE_CURRENT_SOURCE_DIR}/org.freedesktop.login1.Manager.xml"
                            "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Seat.xml"
                            "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Session.xml"
    PROPERTIES INCLUDE "loginddbustypes.h" )

qt5_add_dbus_interface(kworkspace_LIB_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/org.freedesktop.login1.Manager.xml" login1_manager_interface)
# The autogenerated cpp file hardcodes the interface name given to the QDBusAbstractAdaptor
# This "hack" swaps the implementation for one that can switch between login1 and consolekit2
list(REMOVE_ITEM kworkspace_LIB_SRCS "${CMAKE_CURRENT_BINARY_DIR}/login1_manager_interface.cpp")
list(APPEND kworkspace_LIB_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/login1_manager_interface.cpp")

qt5_add_dbus_interface(kworkspace_LIB_SRCS "org.freedesktop.UPower.xml" upower_interface)
qt5_add_dbus_interface(kworkspace_LIB_SRCS "org.freedesktop.ConsoleKit.Manager.xml" consolekit_manager_interface)

set(ksmserver_xml ${plasma-workspace_SOURCE_DIR}/ksmserver/org.kde.KSMServerInterface.xml)
qt5_add_dbus_interface( kworkspace_LIB_SRCS ${ksmserver_xml} ksmserver_interface )

add_library(kworkspace ${kworkspace_LIB_SRCS})
add_library(PW::KWorkspace ALIAS kworkspace)
set_target_properties(kworkspace PROPERTIES
                             VERSION ${PROJECT_VERSION}
                             SOVERSION ${PROJECT_VERSION_MAJOR}
                             EXPORT_NAME KWorkspace
                             OUTPUT_NAME kworkspace5
                      )

generate_export_header(kworkspace)
target_link_libraries(kworkspace
    PUBLIC
        Qt5::Core
        KF5::CoreAddons
    PRIVATE
        Qt5::DBus
        KF5::I18n
        KF5::WindowSystem
        KF5::ConfigCore
)
target_include_directories(kworkspace PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
                                      INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/kworkspace5>" )

configure_file(config-libkworkspace.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-libkworkspace.h)

if(X11_FOUND)
    if(NOT X11_Xau_FOUND)
        message(FATAL_ERROR "Found X11, but not libXau which is required for building kworkspace")
    endif()
    target_link_libraries(kworkspace PRIVATE Qt5::X11Extras ${X11_LIBRARIES} ${X11_Xau_LIB})
endif()

write_basic_config_version_file(${CMAKE_CURRENT_BINARY_DIR}/LibKWorkspaceConfigVersion.cmake VERSION
                                     "${PROJECT_VERSION}" COMPATIBILITY AnyNewerVersion)

install(TARGETS kworkspace EXPORT libkworkspaceLibraryTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install( FILES kdisplaymanager.h
               kworkspace.h
               sessionmanagement.h
               updatelaunchenvjob.h
               ${CMAKE_CURRENT_BINARY_DIR}/config-libkworkspace.h
               ${CMAKE_CURRENT_BINARY_DIR}/kworkspace_export.h
         DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kworkspace5 COMPONENT Devel )

set(CMAKECONFIG_INSTALL_DIR ${KDE_INSTALL_LIBDIR}/cmake/LibKWorkspace)
configure_package_config_file(LibKWorkspaceConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/LibKWorkspaceConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/LibKWorkspaceConfig.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/LibKWorkspaceConfigVersion.cmake
        DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(EXPORT libkworkspaceLibraryTargets
        NAMESPACE PW::
        DESTINATION ${CMAKECONFIG_INSTALL_DIR}
        FILE LibKWorkspaceLibraryTargets.cmake )

if(BUILD_TESTING)
    add_subdirectory(autotests)
    add_subdirectory(tests)
endif()

=== libtaskmanager/CMakeLists.txt ===
add_subdirectory(declarative)
if(BUILD_TESTING)
   add_subdirectory(autotests)
endif()

set(taskmanager_LIB_SRCS
    abstracttasksmodel.cpp
    abstracttasksproxymodeliface.cpp
    abstractwindowtasksmodel.cpp
    activityinfo.cpp
    concatenatetasksproxymodel.cpp
    flattentaskgroupsproxymodel.cpp
    launchertasksmodel.cpp
    startuptasksmodel.cpp
    taskfilterproxymodel.cpp
    taskgroupingproxymodel.cpp
    tasksmodel.cpp
    tasktools.cpp
    virtualdesktopinfo.cpp
    waylandtasksmodel.cpp
    windowtasksmodel.cpp
)

if (X11_FOUND)
    set(taskmanager_LIB_SRCS
        ${taskmanager_LIB_SRCS}
        xwindowsystemeventbatcher.cpp
        xwindowtasksmodel.cpp
    )
endif()

add_library(taskmanager ${taskmanager_LIB_SRCS})
add_library(PW::LibTaskManager ALIAS taskmanager)

generate_export_header(taskmanager)

target_include_directories(taskmanager PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>" "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/taskmanager>")

target_link_libraries(taskmanager
    PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Quick
        KF5::ItemModels
    PRIVATE
        Qt5::DBus
        KF5::Activities
        KF5::ConfigCore
        KF5::I18n
        KF5::KIOCore
        KF5::KIOGui
        KF5::KIOWidgets
        KF5::Notifications
        KF5::WaylandClient
        KF5::WindowSystem
)

if (X11_FOUND)
    target_link_libraries(taskmanager
        PRIVATE
            Qt5::X11Extras
            KF5::IconThemes)
endif()

set_target_properties(taskmanager PROPERTIES
                      VERSION ${PROJECT_VERSION}
                      SOVERSION 6
                      EXPORT_NAME LibTaskManager)

install(TARGETS taskmanager EXPORT libtaskmanagerLibraryTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES
    abstracttasksmodel.h
    abstracttasksmodeliface.h
    abstracttasksproxymodeliface.h
    abstractwindowtasksmodel.h
    activityinfo.h
    concatenatetasksproxymodel.h
    flattentaskgroupsproxymodel.h
    launchertasksmodel.h
    startuptasksmodel.h
    taskfilterproxymodel.h
    taskgroupingproxymodel.h
    tasksmodel.h
    tasktools.h
    virtualdesktopinfo.h
    waylandtasksmodel.h
    windowtasksmodel.h
    ${CMAKE_CURRENT_BINARY_DIR}/taskmanager_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/taskmanager COMPONENT Devel
)

if (X11_FOUND)
    install(FILES
        xwindowtasksmodel.h
        DESTINATION ${KDE_INSTALL_INCLUDEDIR}/taskmanager COMPONENT Devel
    )
endif()

write_basic_config_version_file(${CMAKE_CURRENT_BINARY_DIR}/LibTaskManagerConfigVersion.cmake VERSION "${PROJECT_VERSION}" COMPATIBILITY AnyNewerVersion)

set(CMAKECONFIG_INSTALL_DIR ${KDE_INSTALL_LIBDIR}/cmake/LibTaskManager)

configure_package_config_file(LibTaskManagerConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/LibTaskManagerConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LibTaskManagerConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/LibTaskManagerConfigVersion.cmake
        DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(EXPORT libtaskmanagerLibraryTargets
        NAMESPACE PW::
        DESTINATION ${CMAKECONFIG_INSTALL_DIR}
        FILE LibTaskManagerLibraryTargets.cmake )

install(FILES taskmanagerrulesrc
        DESTINATION ${KDE_INSTALL_CONFDIR})

=== login-sessions/CMakeLists.txt ===
## For Plasma end users

configure_file(plasma.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/plasma.desktop)
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/plasma.desktop
        DESTINATION ${KDE_INSTALL_DATADIR}/xsessions
)

configure_file(plasmawayland.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/plasmawayland.desktop)
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/plasmawayland.desktop
        DESTINATION ${KDE_INSTALL_DATADIR}/wayland-sessions
)

## For Plasma developers
configure_file(startplasma-dev.sh.cmake ${CMAKE_CURRENT_BINARY_DIR}/startplasma-dev.sh)
configure_file(plasmax11-dev.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/plasmax11-dev.desktop)
configure_file(plasmawayland-dev.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/plasmawayland-dev.desktop)
configure_file(install-sessions.sh.cmake ${CMAKE_CURRENT_BINARY_DIR}/install-sessions.sh)

=== plasmacalendarintegration/CMakeLists.txt ===
add_definitions("-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII")
add_definitions(-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)
add_definitions(-DQT_NO_URL_CAST_FROM_STRING)

set(holidays-plugin_SRCS
    holidaysevents.cpp
)

add_library(holidaysevents MODULE ${holidays-plugin_SRCS})
target_link_libraries(holidaysevents Qt5::Core
                                     KF5::ConfigCore
                                     KF5::Holidays
                                     KF5::CalendarEvents
)

install (TARGETS holidaysevents
         DESTINATION ${KDE_INSTALL_PLUGINDIR}/plasmacalendarplugins
)

install (FILES HolidaysConfig.qml
         DESTINATION ${KDE_INSTALL_PLUGINDIR}/plasmacalendarplugins/holidays
)

add_subdirectory(qmlhelper)

=== runners/CMakeLists.txt ===
add_subdirectory(activities)
if(KF5Baloo_FOUND)
 add_subdirectory(baloo)
endif()
add_subdirectory(bookmarks)
add_subdirectory(calculator)
add_subdirectory(locations)
add_subdirectory(places)
add_subdirectory(services)
add_subdirectory(recentdocuments)
add_subdirectory(shell)
add_subdirectory(webshortcuts)
add_subdirectory(windowedwidgets)

if(AppStreamQt_FOUND)
    add_subdirectory(appstream)
endif()

if(NOT WIN32)
 add_subdirectory(powerdevil)
 add_subdirectory(sessions)
 add_subdirectory(windows)
 add_subdirectory(kill)
endif()
#

=== shell/CMakeLists.txt ===
configure_file(config-ktexteditor.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-ktexteditor.h )

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config-plasma.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-plasma.h)

add_definitions(-DPLASMA_DEPRECATED=)

set(scripting_SRC
    scripting/appinterface.cpp
    scripting/applet.cpp
    scripting/containment.cpp
    scripting/configgroup.cpp
    scripting/panel.cpp
    scripting/scriptengine.cpp
    scripting/scriptengine_v1.cpp
    scripting/widget.cpp
)

set(plasmashell_dbusXML dbus/org.kde.PlasmaShell.xml)
qt5_add_dbus_adaptor(scripting_SRC ${plasmashell_dbusXML} shellcorona.h ShellCorona plasmashelladaptor)

ecm_qt_declare_logging_category(plasmashell HEADER debug.h
                                               IDENTIFIER PLASMASHELL
                                               CATEGORY_NAME kde.plasmashell
                                               DEFAULT_SEVERITY Info)

set (plasma_shell_SRCS
    alternativeshelper.cpp
    main.cpp
    containmentconfigview.cpp
    currentcontainmentactionsmodel.cpp
    desktopview.cpp
    panelview.cpp
    panelconfigview.cpp
    panelshadows.cpp
    shellcorona.cpp
    standaloneappcorona
    osd.cpp
    coronatesthelper.cpp
    strutmanager.cpp
    debug.cpp
    screenpool.cpp
    softwarerendernotifier.cpp
    ${scripting_SRC}
)

if (TARGET KUserFeedbackCore)
    set(plasma_shell_SRCS
        ${plasma_shell_SRCS}
        userfeedback.cpp
    )
endif()

set(krunner_xml ${plasma-workspace_SOURCE_DIR}/krunner/dbus/org.kde.krunner.App.xml)
qt5_add_dbus_interface(plasma_shell_SRCS ${krunner_xml} krunner_interface)


add_executable(plasmashell
    ${plasma_shell_SRCS}
)

target_link_libraries(plasmashell
 Qt5::Quick
 Qt5::DBus
 KF5::KIOCore
 KF5::WindowSystem
 KF5::Crash
 KF5::Plasma
 KF5::PlasmaQuick
 KF5::Solid
 KF5::Declarative
 KF5::I18n
 KF5::Activities
 KF5::GlobalAccel
 KF5::CoreAddons
 KF5::DBusAddons
 KF5::QuickAddons
 KF5::XmlGui
 KF5::Package
 KF5::WaylandClient
 KF5::Notifications
 PW::KWorkspace
)
if (TARGET KUserFeedbackCore)
    target_link_libraries(plasmashell KUserFeedbackCore)
    target_compile_definitions(plasmashell PRIVATE -DWITH_KUSERFEEDBACKCORE)
endif()

target_include_directories(plasmashell PRIVATE "${CMAKE_BINARY_DIR}")
target_compile_definitions(plasmashell PRIVATE -DPROJECT_VERSION="${PROJECT_VERSION}")

if(HAVE_X11)
  target_link_libraries(plasmashell ${X11_LIBRARIES} ${XCB_LIBRARIES} )
  target_link_libraries(plasmashell Qt5::X11Extras)
endif()

configure_file(org.kde.plasmashell.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/org.kde.plasmashell.desktop @ONLY)

install(TARGETS plasmashell ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.plasmashell.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.plasmashell.desktop DESTINATION ${KDE_INSTALL_AUTOSTARTDIR})
install( FILES dbus/org.kde.PlasmaShell.xml DESTINATION ${KDE_INSTALL_DBUSINTERFACEDIR} )

install(FILES
   scripting/plasma-layouttemplate.desktop
   DESTINATION ${KDE_INSTALL_KSERVICETYPES5DIR})

add_subdirectory(packageplugins)
if(BUILD_TESTING)
   add_subdirectory(autotests)
endif()

=== debian/changelog ===
plasma-workspace (4:5.20.5-7mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Add ksmserver_reject_new_clients_when_in_killing_state.patch

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 08 Feb 2022 15:31:54 -0800

plasma-workspace (4:5.20.5-6) unstable; urgency=medium

  * Add breaks+replaces for plasma-workspace in plasma-workspace-data as
    this can cause files to disappear on an buster->bullseye upgrade.
    Thx to Andreas Beckmann (Closes: #988098).

 -- Patrick Franz <patfra71@gmail.com>  Fri, 07 May 2021 20:58:22 +0200

plasma-workspace (4:5.20.5-5) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Cherry-pick upstream calculator fixes for KRunner:
    - Single digit factorials.
    - Parsing of hexadecimal numbers.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 01 Mar 2021 00:13:07 +0100

plasma-workspace (4:5.20.5-4) unstable; urgency=medium

  * Team upload.

  [ Norbert Preining ]
  * Cherry-pick (and adjust) upstream fix for knsrc usage in wallpaper.knsrc

  [ Aurélien COUDERC ]
  * Cherry-pick upstream fix for X11 variables setup in wayland startup.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 24 Feb 2021 13:34:53 +0100

plasma-workspace (4:5.20.5-3) unstable; urgency=medium

  * Update upstream metadata.
  * Rebuild against new e-c-m to fix broken template tar.

 -- Norbert Preining <norbert@preining.info>  Sun, 24 Jan 2021 14:45:06 +0900

plasma-workspace (4:5.20.5-2) unstable; urgency=medium

  * Team upload.
  * Backport upstream LTS bugfixes:
    - [lookandfeel] Avoid rendering invisible contents (fixes random lockscreen
      100% usage issue).
    - [lookandfeel] Fix wake existing screensaver mode with key presses
  * Build with hardening=+all build hardening flag.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 14 Jan 2021 10:09:30 +0100

plasma-workspace (4:5.20.5-1) unstable; urgency=medium

  * New upstream release (5.20.5).

 -- Norbert Preining <norbert@preining.info>  Wed, 06 Jan 2021 23:50:53 +0900

plasma-workspace (4:5.20.4-6) unstable; urgency=medium

  * Add breeze-dev to B-D (optional package).
  * Remove plasma-workspace-wallpapers from B-D.

 -- Norbert Preining <norbert@preining.info>  Mon, 28 Dec 2020 09:31:32 +0900

plasma-workspace (4:5.20.4-5) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Tue, 22 Dec 2020 11:04:38 +0900

plasma-workspace (4:5.20.4-4) experimental; urgency=medium

  * Team upload.

  [ Sandro Knauß ]
  * Add Breaks/Replaces for plasma-workspace-data against plasma-
    desktop.

  [ Norbert Preining ]
  * Add qml-module-org-kde-prison to the deps of p-w.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 19 Dec 2020 14:30:07 +0100

plasma-workspace (4:5.20.4-3) experimental; urgency=medium

  * Team upload.
  * Add missing runtime dependency to qml-module-org-kde-userfeedback for the
    user feedback KCM.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 16 Dec 2020 10:14:30 +0100

plasma-workspace (4:5.20.4-2) experimental; urgency=medium

  * Rebuild for Qt transition.

 -- Norbert Preining <norbert@preining.info>  Sun, 13 Dec 2020 00:41:38 +0900

plasma-workspace (4:5.20.4-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.20.4).
  * Update build-deps with the info from cmake.
  * Add libkfontinst* packages.
  * Remove applied patches:
    . fix-plasma-desktop-type
    . upstream_Fix-missing-Switch-User-button-on-lockscreen-with-sy.patch
    . upstream_libkworkspace-Fix-if-getCurrentSeat-needs-to-fallbac.patch
    . upstream_libkworkspace-Port-from-deprecated-GetSessionByPID.patch
  * Update symbols.
  * Update list of installed files.
  * Add Replaces/Breaks for files moved from plasma-desktop.
  * Include plasma-desktop patch allow_uxterm_overrides.diff

  [ Pino Toscano ]
  * Switch the transitional libxcb-util0-dev build dependency to
    libxcb-util-dev.
  * Bump Standards-Version to 4.5.1, no changes required.
  * Update renamed lintian tag names in lintian overrides.
  * Remove listed license files (COPYING.LIB) from copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Norbert Preining <norbert@preining.info>  Wed, 09 Dec 2020 14:17:33 +0900

plasma-workspace (4:5.19.5-5) unstable; urgency=medium

  [ Scarlett Moore ]
  * Fix "Undefined symbols: Need rebuild ?" tighten dependencies with kwin*
    dependencies. (Closes: #974430)
  * Bump all build dependencies according to cmake.
    - Add build dependencies needed by kpackage metainfo generator.
  * Refresh symbol files. Removed 1 optional MISSING.
  * Refresh install files.

  [ Sandro Knauß ]
  * Fix "No "Switch-User" with systemd V246" (Closes: #970742)
    - add upstream patch:
      upstream_libkworkspace-Fix-if-getCurrentSeat-needs-to-fallbac.patch
      upstream_libkworkspace-Port-from-deprecated-GetSessionByPID.patch
      upstream_Fix-missing-Switch-User-button-on-lockscreen-with-sy.patch

 -- Norbert Preining <norbert@preining.info>  Tue, 17 Nov 2020 11:00:46 +0900

plasma-workspace (4:5.19.5-4) unstable; urgency=medium

  [ Debian Qt/KDE Maintainers ]
  * Add missing Breaks/Replaces against p-desktop-data (Closes: #974054)

 -- Norbert Preining <norbert@preining.info>  Tue, 10 Nov 2020 05:57:59 +0900

plasma-workspace (4:5.19.5-3) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Fri, 06 Nov 2020 08:37:24 +0900

plasma-workspace (4:5.19.5-2) experimental; urgency=medium

  * Rebuild for Qt 5.15

 -- Norbert Preining <norbert@preining.info>  Mon, 02 Nov 2020 09:27:43 +0900

plasma-workspace (4:5.19.5-1) experimental; urgency=medium

  * New upstream release (5.19.5).
  * Add Patrick and myself to uploaders.

 -- Norbert Preining <norbert@preining.info>  Mon, 19 Oct 2020 18:49:21 +0900

plasma-workspace (4:5.19.4-2) experimental; urgency=medium

  * Team upload.

  [ Norbert Preining ]


=== debian/control ===
Source: plasma-workspace
Section: kde
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Scarlett Moore <sgmoore@kde.org>,
           Patrick Franz <patfra71@gmail.com>,
           Norbert Preining <norbert@preining.info>
Build-Depends: baloo-kf5-dev (>= 5.13~),
               breeze-dev (>= 4:5.20.4~),
               cmake (>= 3.0~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.74.0~),
               iso-codes,
               kded5-dev (>= 5.74.0~),
               kinit-dev (>= 5.74.0~),
               kirigami2-dev (>= 5.74.0~),
               kquickcharts-dev (>= 5.74.0~),
               kscreenlocker-dev (>= 5.20~),
               kuserfeedback-dev,
               kwin-dev (>= 4:5.20~),
               libappstreamqt-dev (>= 0.10.6~) [linux-any],
               libdbusmenu-qt5-dev,
               libdrm-dev,
               libfontconfig-dev,
               libfreetype-dev,
               libgps-dev,
               libkf5activities-dev (>= 5.74.0~),
               libkf5activitiesstats-dev (>= 5.74.0~),
               libkf5config-dev (>= 5.74.0~),
               libkf5coreaddons-dev (>= 5.74.0~),
               libkf5crash-dev (>= 5.74.0~),
               libkf5dbusaddons-dev (>= 5.74.0~),
               libkf5declarative-dev (>= 5.74.0~),
               libkf5doctools-dev (>= 5.74.0~),
               libkf5globalaccel-dev (>= 5.74.0~),
               libkf5holidays-dev (>= 5.74.0~),
               libkf5i18n-dev (>= 5.74.0~),
               libkf5idletime-dev (>= 5.74.0~),
               libkf5itemmodels-dev (>= 5.74.0~),
               libkf5kcmutils-dev (>= 5.74.0~),
               libkf5kdelibs4support-dev (>= 5.74.0~),
               libkf5kio-dev (>= 5.74.0~),
               libkf5networkmanagerqt-dev (>= 5.74.0~),
               libkf5newstuff-dev (>= 5.74.0~),
               libkf5notifyconfig-dev (>= 5.74.0~),
               libkf5package-dev (>= 5.74.0~),
               libkf5people-dev (>= 5.74.0~),
               libkf5plasma-dev (>= 5.74.0~),
               libkf5prison-dev (>= 5.74.0~),
               libkf5runner-dev (>= 5.74.0~),
               libkf5screen-dev (>= 4:5.20~),
               libkf5solid-dev (>= 5.74.0~),
               libkf5su-dev (>= 5.74.0~),
               libkf5sysguard-dev (>= 4:5.20.0~),
               libkf5texteditor-dev (>= 5.74.0),
               libkf5textwidgets-dev (>= 5.74.0~),
               libkf5wallet-dev (>= 5.74.0~),
               libkf5wayland-dev (>= 4:5.74.0~),
               libphonon4qt5-dev (>= 4:4.8.0-5),
               libphonon4qt5experimental-dev,
               libpipewire-0.3-dev,
               libqalculate-dev,
               libqt5svg5-dev (>= 5.15.0~),
               libqt5waylandclient5-dev (>= 5.15.0~),
               libqt5x11extras5-dev (>= 5.15.0~),
               libsm-dev,
               libudev-dev,
               libwayland-dev (>= 1.3),
               libx11-dev,
               libx11-xcb-dev,
               libxcb-composite0-dev,
               libxcb-damage0-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-shm0-dev,
               libxcb-util-dev,
               libxcb1-dev,
               libxcursor-dev,
               libxft-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxkbfile-dev,
               libxrandr-dev,
               libxrender-dev,
               libxtst-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.18~),
               plasma-framework (>= 5.74.0~),
               plasma-wayland-protocols,
               qtbase5-dev (>= 5.15.0~),
               qtbase5-private-dev (>= 5.15.0~),
               qtdeclarative5-dev (>= 5.15.0~),
               qttools5-dev (>= 5.15.0~),
               qtwayland5-dev-tools,
               xcb-proto,
               zlib1g-dev
Standards-Version: 4.5.1
Homepage: https://invent.kde.org/plasma/plasma-workspace
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/plasma-workspace
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/plasma-workspace.git
Rules-Requires-Root: no

Package: libcolorcorrect5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 ColorCorrect library.
 .
 This package contains library files.

Package: libkfontinst5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Tools and widgets for the desktop library
 Plasma Desktop offers a beautiful looking desktop
 that takes complete advantage of modern computing technology.
 Through the use of visual effects and scalable graphics,
 the desktop experience is not only smooth but also pleasant
 to the eye. The looks of Plasma Desktop not only provide beauty,
 they are also used to support and improve your computer
 activities effectively, without being distracting.
 .
 This package is part of the KDE Plasma.

Package: libkfontinstui5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Tools and widgets for the desktop library
 Plasma Desktop offers a beautiful looking desktop
 that takes complete advantage of modern computing technology.
 Through the use of visual effects and scalable graphics,
 the desktop experience is not only smooth but also pleasant
 to the eye. The looks of Plasma Desktop not only provide beauty,
 they are also used to support and improve your computer
 activities effectively, without being distracting.
 .
 This package is part of the KDE Plasma.

Package: libkworkspace5-5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Kworkspace library.
 .
 This package contains library files.

Package: libnotificationmanager1
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Taskmanager library.
 .
 This package contains library files.

Package: libplasma-geolocation-interface5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Interface library for geolocation.
 .
 This package contains library files.

Package: libtaskmanager6abi1
X-Debian-ABI: 1
X-CMake-Target: taskmanager
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Taskmanager library.
 .
 This package contains library files.

Package: libweather-ion7
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Plasma Workspace for KF5 library
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 Weather_ion library.
 .
 This package contains library files.

Package: plasma-workspace
Architecture: any
Depends: default-dbus-session-bus | dbus-session-bus,
         drkonqi (>= 5.20~),
         frameworkintegration,
         gdb-minimal | gdb,
         iso-codes,
         kactivitymanagerd (>= 5.20~),
         kded5,
         kinit,
         kio,
         kwin-common (>= 4:5.20~),
         libkf5config-bin,
         libkf5globalaccel-bin (>= 5.7.0),
         libkf5plasma5 (>= 5.74.0~),
         libkf5service-bin,
         milou (>= 4:5.20~),
         plasma-framework,
         plasma-integration (>= 5.20~),
         plasma-workspace-data (>= ${source:Version}),
         qdbus-qt5,
         qml-module-org-kde-draganddrop,
         qml-module-org-kde-kcoreaddons,
         qml-module-org-kde-kholidays,
         qml-module-org-kde-kquickcontrols,
         qml-module-org-kde-kquickcontrolsaddons,
         qml-module-org-kde-ksysguard,
         qml-module-org-kde-kwindowsystem,
         qml-module-org-kde-prison,
         qml-module-org-kde-quickcharts,
         qml-module-org-kde-solid,
         qml-module-org-kde-userfeedback,
         qml-module-qt-labs-folderlistmodel,
         qml-module-qtgraphicaleffects,
         qml-module-qtqml-models2,
         qml-module-qtquick-controls,
         qml-module-qtquick-dialogs,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         udisks2,
         x11-utils,
         x11-xserver-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: notification-daemon, x-session-manager
Recommends: kde-cli-tools (>= 4:5.20~),
            kio-extras,
            ksysguardd (>= 4:5.20~),
            libpam-kwallet5 (>= 5.14),
            powerdevil (>= 4:5.14)
Breaks: plasma-desktop (<< 4:5.20~), plasma-desktop-data (<< 4:5.20~)
Replaces: plasma-desktop (<< 4:5.20~), plasma-desktop-data (<< 4:5.20~)
Description: Plasma Workspace for KF5
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 .
 THIS WILL REMOVE YOUR KDE Plasma 4.

Package: plasma-workspace-data
Architecture: all
Depends: ${misc:Depends}
Breaks: plasma-desktop (<< 4:5.20~),
        plasma-desktop-data (<< 4:5.20~),
        plasma-workspace (<< 4:5.20~)
Replaces: plasma-desktop (<< 4:5.20~),
          plasma-desktop-data (<< 4:5.20~),
          plasma-workspace (<< 4:5.20~)
Description: Plasma Workspace for KF5 - data files
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 .
 This contains the data files for the Plasma workspace.

Package: plasma-workspace-dev
Architecture: any
Section: libdevel
Depends: kquickcharts-dev (>= 5.20~),
         libkf5itemmodels-dev (>= 5.74.0~),
         libkf5plasma-dev (>= 5.74.0~),
         libkf5sysguard-dev (>= 4:5.18),
         libkf5windowsystem-dev (>= 5.74.0~),
         qtbase5-dev (>= 5.15.0~),
         qtdeclarative5-dev (>= 5.15.0~),
         ${misc:Depends},
         ${so:Depends}
Breaks: plasma-desktop-dev (<< 4:5.20~)
Replaces: plasma-desktop-dev (<< 4:5.20~)
Description: Plasma Workspace for KF5 devel files
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 .
 This package contains the development files.

Package: plasma-workspace-wayland
Architecture: any
Depends: kwayland-integration (>= 5.20~),
         kwin-wayland (>= 4:5.20~),
         plasma-workspace (= ${binary:Version}),
         qtwayland5,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Plasma Workspace for KF5 - Wayland integration
 Plasma Workspace for KF5. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 .
 This package contains the Wayland session.

Package: sddm-theme-breeze
Architecture: any
Depends: plasma-framework, plasma-workspace, ${misc:Depends}, ${shlibs:Depends}
Recommends: sddm
Provides: sddm-theme
Description: Breeze SDDM theme
 Plasma Workspace for KF5. Workspaces provide

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/2/library-packages.mk

%:
	dh $@ --with kf5,pkgkde_symbolshelper,sodeps --buildsystem kf5 --without build_stamp

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_auto_test:
	# Disable auto tests at build time
	:

override_dh_fixperms-arch:
	chmod -x debian/plasma-workspace/etc/xdg/autostart/klipper.desktop
	chmod -x debian/plasma-workspace/usr/lib/*/libexec/plasma-sourceenv.sh
	dh_fixperms -a

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_gencontrol -a

override_dh_strip:
	dh_strip --no-automatic-dbgsym
